JUCE: Label Class Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | Protected Member Functions | List of all members
Label Class Reference
juce_gui_basics » widgets

A component that displays a text string, and can optionally become a text editor when clicked. More...

`#include <juce_Label.h>`

Inheritance diagram for Label:

## Classes
class | Listener
| A class for receiving events from a Label. More...
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide label drawing functionality. More...

## Public Types
enum | ColourIds { backgroundColourId = 0x1000280 , textColourId = 0x1000281 , outlineColourId = 0x1000282 , backgroundWhenEditingColourId = 0x1000283 , textWhenEditingColourId = 0x1000284 , outlineWhenEditingColourId = 0x1000285 }
| A set of colour IDs to use to change the colour of various aspects of the label. More...
Public Types inherited from Component
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions
| Label (const String &componentName=String(), const String &labelText=String())
| Creates a Label.
| ~Label () override
| Destructor.
void | setText (const String &newText, NotificationType notification)
| Changes the label text.
String | getText (bool returnActiveEditorContents=false) const
| Returns the label's current text.
Value & | getTextValue () noexcept
| Returns the text content as a Value object.
void | setFont (const Font &newFont)
| Changes the font to use to draw the text.
Font | getFont () const noexcept
| Returns the font currently being used.
void | setJustificationType (Justification justification)
| Sets the style of justification to be used for positioning the text.
Justification | getJustificationType () const noexcept
| Returns the type of justification, as set in setJustificationType().
void | setBorderSize (BorderSize< int > newBorderSize)
| Changes the border that is left between the edge of the component and the text.
BorderSize< int > | getBorderSize () const noexcept
| Returns the size of the border to be left around the text.
void | attachToComponent (Component *owner, bool onLeft)
| Makes this label "stick to" another component.
Component * | getAttachedComponent () const
| If this label has been attached to another component using attachToComponent, this returns the other component.
bool | isAttachedOnLeft () const noexcept
| If the label is attached to the left of another component, this returns true.
void | setMinimumHorizontalScale (float newScale)
| Specifies the minimum amount that the font can be squashed horizontally before it starts using ellipsis.
float | getMinimumHorizontalScale () const noexcept
| Specifies the amount that the font can be squashed horizontally.
void | setKeyboardType (TextInputTarget::VirtualKeyboardType type) noexcept
| Set a keyboard type for use when the text editor is shown.
void | addListener (Listener *listener)
| Registers a listener that will be called when the label's text changes.
void | removeListener (Listener *listener)
| Deregisters a previously-registered listener.
void | setEditable (bool editOnSingleClick, bool editOnDoubleClick=false, bool lossOfFocusDiscardsChanges=false)
| Makes the label turn into a TextEditor when clicked.
bool | isEditableOnSingleClick () const noexcept
| Returns true if this option was set using setEditable().
bool | isEditableOnDoubleClick () const noexcept
| Returns true if this option was set using setEditable().
bool | doesLossOfFocusDiscardChanges () const noexcept
| Returns true if this option has been set in a call to setEditable().
bool | isEditable () const noexcept
| Returns true if the user can edit this label's text.
void | showEditor ()
| Makes the editor appear as if the label had been clicked by the user.
void | hideEditor (bool discardCurrentEditorContents)
| Hides the editor if it was being shown.
bool | isBeingEdited () const noexcept
| Returns true if the editor is currently focused and active.
TextEditor * | getCurrentTextEditor () const noexcept
| Returns the currently-visible text editor, or nullptr if none is open.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
virtual void | visibilityChanged ()
| Called when this component's visibility changes.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
virtual void | lookAndFeelChanged ()
| Called to let the component react to a change in the look-and-feel setting.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paint (Graphics &g)
| Components can override this method to draw their content.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual bool | keyPressed (const KeyPress &key)
| Called when a key is pressed.
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | resized ()
| Called when this component's size has been changed.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChanged() methods.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
virtual std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler ()
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor.
virtual void | mouseMove (const MouseEvent &event)
| Called when the mouse moves inside a component.
virtual void | mouseEnter (const MouseEvent &event)
| Called when the mouse first enters a component.
virtual void | mouseExit (const MouseEvent &event)
| Called when the mouse moves out of a component.
virtual void | mouseDown (const MouseEvent &event)
| Called when a mouse button is pressed.
virtual void | mouseDrag (const MouseEvent &event)
| Called when the mouse is moved while a button is held down.
virtual void | mouseUp (const MouseEvent &event)
| Called when a mouse button is released.
virtual void | mouseDoubleClick (const MouseEvent &event)
| Called when a mouse button has been double-clicked on a component.
virtual void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel)
| Called when the mouse-wheel is moved.
virtual void | mouseMagnify (const MouseEvent &event, float scaleFactor)
| Called when a pinch-to-zoom mouse-gesture is used.
Public Member Functions inherited from SettableTooltipClient
| ~SettableTooltipClient () override=default
| Destructor.
virtual void | setTooltip (const String &newTooltip)
| Assigns a new tooltip to this object.
String | getTooltip () override
| Returns the tooltip assigned to this object.
Public Member Functions inherited from TooltipClient
virtual | ~TooltipClient ()=default
| Destructor.
virtual String | getTooltip ()=0
| Returns the string that this object wants to show as its tooltip.

## Public Attributes
std::function< void()> | onTextChange
| You can assign a lambda to this callback object to have it called when the label text is changed.
std::function< void()> | onEditorShow
| You can assign a lambda to this callback object to have it called when the label's editor is shown.
std::function< void()> | onEditorHide
| You can assign a lambda to this callback object to have it called when the label's editor is hidden.

## Protected Member Functions
virtual TextEditor * | createEditorComponent ()
| Creates the TextEditor component that will be used when the user has clicked on the label.
virtual void | textWasEdited ()
| Called after the user changes the text.
virtual void | textWasChanged ()
| Called when the text has been altered.
virtual void | editorShown (TextEditor *)
| Called when the text editor has just appeared, due to a user click or other focus change.
virtual void | editorAboutToBeHidden (TextEditor *)
| Called when the text editor is going to be deleted, after editing has finished.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | resized () override
| Called when this component's size has been changed.
void | mouseUp (const MouseEvent &) override
| Called when a mouse button is released.
void | mouseDoubleClick (const MouseEvent &) override
| Called when a mouse button has been double-clicked on a component.
void | componentMovedOrResized (Component &, bool wasMoved, bool wasResized) override
| Called when the component's position or size changes.
void | componentParentHierarchyChanged (Component &) override
| Called to indicate that the component's parents have changed.
void | componentVisibilityChanged (Component &) override
| Called when the component is made visible or invisible.
void | inputAttemptWhenModal () override
| Called when the user tries to click on a component that is blocked by another modal component.
void | focusGained (FocusChangeType) override
| Called to indicate that this component has just acquired the keyboard focus.
void | enablementChanged () override
| Callback to indicate that this component has been enabled or disabled.
std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser () override
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | textEditorTextChanged (TextEditor &) override
| Called when the user changes the text in some way.
void | textEditorReturnKeyPressed (TextEditor &) override
| Called when the user presses the return key.
void | textEditorEscapeKeyPressed (TextEditor &) override
| Called when the user presses the escape key.
void | textEditorFocusLost (TextEditor &) override
| Called when the text editor loses focus.
void | colourChanged () override
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChanged() methods.
void | valueChanged (Value &) override
| Called when a Value object is changed.
void | callChangeListeners ()
Protected Member Functions inherited from SettableTooltipClient
| SettableTooltipClient ()=default
Protected Member Functions inherited from TextEditor::Listener
virtual | ~Listener ()=default
| Destructor.
virtual void | textEditorTextChanged (TextEditor &)
| Called when the user changes the text in some way.
virtual void | textEditorReturnKeyPressed (TextEditor &)
| Called when the user presses the return key.
virtual void | textEditorEscapeKeyPressed (TextEditor &)
| Called when the user presses the escape key.
virtual void | textEditorFocusLost (TextEditor &)
| Called when the text editor loses focus.

## Additional Inherited Members
Static Public Member Functions inherited from Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.

## Detailed Description

A component that displays a text string, and can optionally become a text editor when clicked.

## Member Enumeration Documentation

## ◆ ColourIds

enum Label::ColourIds

A set of colour IDs to use to change the colour of various aspects of the label.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

Note that you can also use the constants from TextEditor::ColourIds to change the colour of the text editor that is opened when a label is editable.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | The background colour to fill the label with.
textColourId | The colour for the text.
outlineColourId | An optional colour to use to draw a border around the label. Leave this transparent to not have an outline.
backgroundWhenEditingColourId | The background colour when the label is being edited.
textWhenEditingColourId | The colour for the text when the label is being edited.
outlineWhenEditingColourId | An optional border colour when the label is being edited.

## Constructor & Destructor Documentation

## ◆ Label()

Label::Label | ( | const String & | componentName = `String()`,
|  | const String & | labelText = `String()`
| ) |  |

Creates a Label.

Parameters

  componentName | the name to give the component
  labelText | the text to show in the label

## ◆ ~Label()

Label::~Label | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ setText()

void Label::setText | ( | const String & | newText,
|  | NotificationType | notification
| ) |  |

Changes the label text.

The NotificationType parameter indicates whether to send a change message to any Label::Listener objects if the new text is different.

## ◆ getText()

String Label::getText | ( | bool | returnActiveEditorContents = `false` | ) | const

Returns the label's current text.

Parameters

  returnActiveEditorContents | if this is true and the label is currently being edited, then this method will return the text as it's being shown in the editor. If false, then the value returned here won't be updated until the user has finished typing and pressed the return key.

Referenced by SidePanel::getTitleText().

## ◆ getTextValue()

Value & Label::getTextValue | ( |  | ) |
| noexcept

Returns the text content as a Value object.

You can call Value::referTo() on this object to make the label read and control a Value object that you supply.

## ◆ setFont()

void Label::setFont | ( | const Font & | newFont | ) |

Changes the font to use to draw the text.

See also
  getFont

## ◆ getFont()

Font Label::getFont | ( |  | ) | const
| noexcept

Returns the font currently being used.

This may be the one set by setFont(), unless it has been overridden by the current LookAndFeel

See also
  setFont

## ◆ setJustificationType()

void Label::setJustificationType | ( | Justification | justification | ) |

Sets the style of justification to be used for positioning the text.

(The default is Justification::centredLeft)

## ◆ getJustificationType()

Justification Label::getJustificationType | ( |  | ) | const
| noexcept

Returns the type of justification, as set in setJustificationType().

## ◆ setBorderSize()

void Label::setBorderSize | ( | BorderSize< int > | newBorderSize | ) |

Changes the border that is left between the edge of the component and the text.

By default there's a small gap left at the sides of the component to allow for the drawing of the border, but you can change this if necessary.

## ◆ getBorderSize()

BorderSize< int > Label::getBorderSize | ( |  | ) | const
| noexcept

Returns the size of the border to be left around the text.

## ◆ attachToComponent()

void Label::attachToComponent | ( | Component * | owner,
|  | bool | onLeft
| ) |  |

Makes this label "stick to" another component.

This will cause the label to follow another component around, staying either to its left or above it.

Parameters

  owner | the component to follow
  onLeft | if true, the label will stay on the left of its component; if false, it will stay above it.

## ◆ getAttachedComponent()

Component * Label::getAttachedComponent | ( |  | ) | const

If this label has been attached to another component using attachToComponent, this returns the other component.

Returns nullptr if the label is not attached.

## ◆ isAttachedOnLeft()

bool Label::isAttachedOnLeft | ( |  | ) | const
| noexcept

If the label is attached to the left of another component, this returns true.

Returns false if the label is above the other component. This is only relevant if attachToComponent() has been called.

## ◆ setMinimumHorizontalScale()

void Label::setMinimumHorizontalScale | ( | float | newScale | ) |

Specifies the minimum amount that the font can be squashed horizontally before it starts using ellipsis.

Use a value of 0 for a default value.

See also
  Graphics::drawFittedText

## ◆ getMinimumHorizontalScale()

float Label::getMinimumHorizontalScale | ( |  | ) | const
| noexcept

Specifies the amount that the font can be squashed horizontally.

## ◆ setKeyboardType()

void Label::setKeyboardType | ( | TextInputTarget::VirtualKeyboardType | type | ) |
| noexcept

Set a keyboard type for use when the text editor is shown.

## ◆ addListener()

void Label::addListener | ( | Listener * | listener | ) |

Registers a listener that will be called when the label's text changes.

## ◆ removeListener()

void Label::removeListener | ( | Listener * | listener | ) |

Deregisters a previously-registered listener.

## ◆ setEditable()

void Label::setEditable | ( | bool | editOnSingleClick,
|  | bool | editOnDoubleClick = `false`,
|  | bool | lossOfFocusDiscardsChanges = `false`
| ) |  |

Makes the label turn into a TextEditor when clicked.

By default this is turned off.

If turned on, then single- or double-clicking will turn the label into an editor. If the user then changes the text, then the ChangeBroadcaster base class will be used to send change messages to any listeners that have registered.

If the user changes the text, the textWasEdited() method will be called afterwards, and subclasses can override this if they need to do anything special.

Parameters

  editOnSingleClick | if true, just clicking once on the label will start editing the text
  editOnDoubleClick | if true, a double-click is needed to start editing
  lossOfFocusDiscardsChanges | if true, clicking somewhere else while the text is being edited will discard any changes; if false, then this will commit the changes.

See also
  showEditor, setEditorColours, TextEditor

## ◆ isEditableOnSingleClick()

bool Label::isEditableOnSingleClick | ( |  | ) | const
| noexcept

Returns true if this option was set using setEditable().

## ◆ isEditableOnDoubleClick()

bool Label::isEditableOnDoubleClick | ( |  | ) | const
| noexcept

Returns true if this option was set using setEditable().

## ◆ doesLossOfFocusDiscardChanges()

bool Label::doesLossOfFocusDiscardChanges | ( |  | ) | const
| noexcept

Returns true if this option has been set in a call to setEditable().

## ◆ isEditable()

bool Label::isEditable | ( |  | ) | const
| noexcept

Returns true if the user can edit this label's text.

## ◆ showEditor()

void Label::showEditor | ( |  | ) |

Makes the editor appear as if the label had been clicked by the user.

See also
  textWasEdited, setEditable

## ◆ hideEditor()

void Label::hideEditor | ( | bool | discardCurrentEditorContents | ) |

Hides the editor if it was being shown.

Parameters

  discardCurrentEditorContents | if true, the label's text will be reset to whatever it was before the editor was shown; if false, the current contents of the editor will be used to set the label's text before it is hidden.

## ◆ isBeingEdited()

bool Label::isBeingEdited | ( |  | ) | const
| noexcept

Returns true if the editor is currently focused and active.

## ◆ getCurrentTextEditor()

TextEditor * Label::getCurrentTextEditor | ( |  | ) | const
| noexcept

Returns the currently-visible text editor, or nullptr if none is open.

## ◆ createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > Label::createAccessibilityHandler | ( |  | ) |
| overridevirtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from Component.

## ◆ createEditorComponent()

virtual TextEditor * Label::createEditorComponent | ( |  | ) |
| protectedvirtual

Creates the TextEditor component that will be used when the user has clicked on the label.

Subclasses can override this if they need to customise this component in some way.

## ◆ textWasEdited()

virtual void Label::textWasEdited | ( |  | ) |
| protectedvirtual

Called after the user changes the text.

## ◆ textWasChanged()

virtual void Label::textWasChanged | ( |  | ) |
| protectedvirtual

Called when the text has been altered.

## ◆ editorShown()

virtual void Label::editorShown | ( | TextEditor * |  | ) |
| protectedvirtual

Called when the text editor has just appeared, due to a user click or other focus change.

## ◆ editorAboutToBeHidden()

virtual void Label::editorAboutToBeHidden | ( | TextEditor * |  | ) |
| protectedvirtual

Called when the text editor is going to be deleted, after editing has finished.

## ◆ paint()

void Label::paint | ( | Graphics & | g | ) |
| overrideprotectedvirtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from Component.

## ◆ resized()

void Label::resized | ( |  | ) |
| overrideprotectedvirtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented from Component.

## ◆ mouseUp()

void Label::mouseUp | ( | const MouseEvent & | event | ) |
| overrideprotectedvirtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from Component.

## ◆ mouseDoubleClick()

void Label::mouseDoubleClick | ( | const MouseEvent & | event | ) |
| overrideprotectedvirtual

Called when a mouse button has been double-clicked on a component.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp

Reimplemented from Component.

## ◆ componentMovedOrResized()

void Label::componentMovedOrResized | ( | Component & | component,
|  | bool | wasMoved,
|  | bool | wasResized
| ) |  |
| overrideprotectedvirtual

Called when the component's position or size changes.

Parameters

  component | the component that was moved or resized
  wasMoved | true if the component's top-left corner has just moved
  wasResized | true if the component's width or height has just changed

See also
  Component::setBounds, Component::resized, Component::moved

Reimplemented from ComponentListener.

## ◆ componentParentHierarchyChanged()

void Label::componentParentHierarchyChanged | ( | Component & | component | ) |
| overrideprotectedvirtual

Called to indicate that the component's parents have changed.

When a component is added or removed from its parent, all of its children will produce this notification (recursively - so all children of its children will also be called as well).

Parameters

  component | the component that this listener is registered with

See also
  Component::parentHierarchyChanged

Reimplemented from ComponentListener.

## ◆ componentVisibilityChanged()

void Label::componentVisibilityChanged | ( | Component & | component | ) |
| overrideprotectedvirtual

Called when the component is made visible or invisible.

Parameters

  component | the component that changed

See also
  Component::setVisible

Reimplemented from ComponentListener.

## ◆ inputAttemptWhenModal()

void Label::inputAttemptWhenModal | ( |  | ) |
| overrideprotectedvirtual

Called when the user tries to click on a component that is blocked by another modal component.

When a component is modal and the user clicks on one of the other components, the modal component will receive this callback.

The default implementation of this method will play a beep, and bring the currently modal component to the front, but it can be overridden to do other tasks.

See also
  isCurrentlyBlockedByAnotherModalComponent, canModalEventBeSentToComponent

Reimplemented from Component.

## ◆ focusGained()

void Label::focusGained | ( | FocusChangeType | cause | ) |
| overrideprotectedvirtual

Called to indicate that this component has just acquired the keyboard focus.

See also
  focusLost, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from Component.

## ◆ enablementChanged()

void Label::enablementChanged | ( |  | ) |
| overrideprotectedvirtual

Callback to indicate that this component has been enabled or disabled.

This can be triggered by one of the component's parent components being enabled or disabled, as well as changes to the component itself.

The default implementation of this method does nothing; your class may wish to repaint itself or something when this happens.

See also
  setEnabled, isEnabled

Reimplemented from Component.

## ◆ createKeyboardFocusTraverser()

std::unique_ptr< ComponentTraverser > Label::createKeyboardFocusTraverser | ( |  | ) |
| overrideprotectedvirtual

Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.

The default implementation of this method will return an instance of KeyboardFocusTraverser if this component is a keyboard focus container (as determined by the setFocusContainerType() method). If the component isn't a keyboard focus container, then it will recursively call createKeyboardFocusTraverser() on its parents.

If you override this to return a custom traverser object, then this component and all its sub-components will use the new object to make their keyboard focusing decisions.

Reimplemented from Component.

## ◆ textEditorTextChanged()

void Label::textEditorTextChanged | ( | TextEditor & |  | ) |
| overrideprotectedvirtual

Called when the user changes the text in some way.

Reimplemented from TextEditor::Listener.

## ◆ textEditorReturnKeyPressed()

void Label::textEditorReturnKeyPressed | ( | TextEditor & |  | ) |
| overrideprotectedvirtual

Called when the user presses the return key.

Reimplemented from TextEditor::Listener.

## ◆ textEditorEscapeKeyPressed()

void Label::textEditorEscapeKeyPressed | ( | TextEditor & |  | ) |
| overrideprotectedvirtual

Called when the user presses the escape key.

Reimplemented from TextEditor::Listener.

## ◆ textEditorFocusLost()

void Label::textEditorFocusLost | ( | TextEditor & |  | ) |
| overrideprotectedvirtual

Called when the text editor loses focus.

Reimplemented from TextEditor::Listener.

## ◆ colourChanged()

void Label::colourChanged | ( |  | ) |
| overrideprotectedvirtual

This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChanged() methods.

See also
  setColour, findColour, setLookAndFeel, sendLookAndFeelChanged

Reimplemented from Component.

## ◆ valueChanged()

void Label::valueChanged | ( | Value & | value | ) |
| overrideprotectedvirtual

Called when a Value object is changed.

Note that the Value object passed as a parameter may not be exactly the same object that you registered the listener with - it might be a copy that refers to the same underlying ValueSource. To find out, you can call Value::refersToSameSourceAs().

Implements Value::Listener.

## ◆ callChangeListeners()

void Label::callChangeListeners | ( |  | ) |
| protected

## Member Data Documentation

## ◆ onTextChange

std::function<void()> Label::onTextChange

You can assign a lambda to this callback object to have it called when the label text is changed.

## ◆ onEditorShow

std::function<void()> Label::onEditorShow

You can assign a lambda to this callback object to have it called when the label's editor is shown.

## ◆ onEditorHide

std::function<void()> Label::onEditorHide

You can assign a lambda to this callback object to have it called when the label's editor is hidden.

The documentation for this class was generated from the following file:

- juce_Label.h